Subject: Re: [bitcoin-dev] Making AsicBoost irrelevant

From: Matt Corallo <[email-masked]>
Date: Tue, 10 May 2016 22:59:52 +0000

Replies inline.

On 05/10/16 21:43, Sergio Demian Lerner via bitcoin-dev wrote:
-snip-

> But some ASIC companies already have cores that are better (on power,
> cost, rate, temperature, etc.) than competing companies ASICs. Why do
> you think a 10% improvement from AsicBoost is different from many of
> other improvements they already have (secretly) added? Maybe we (?)
> should only allow ASICs that have a 100% open source designs?

One is patented and requires paying a license fee to a group, or more
likely, ends up with it being impossible to import hardware from other
jurisdictions into the US/western world. The other requires more
investment in R&D, and over the long run, there is no guaranteed
advantage to such groups.

> If we change the protocol then the message to the ecosystem is that ASIC
> optimizations should be kept secret.

To some extent, this is the case, but there is a strong difference
between a guaranteed advantage enforced by the legal system and one that
is true due to intellectual superiority. In the long run, I am confident
the second will not remain the case. For example, AsicBoost was
independently discovered by at least two companies/individuals within a
year or two.

> It is fair to change the protocol
> because we don't like that certain ASIC manufacturer has better chips,
> if the chips are sold in the market and anyone can buy them? And what
> about using approximate adders (30% improvement), or dual rail
> asynchronous adders (also more than 10% improvement) ? How do we repair
> those?

As far as I'm aware neither of these are patented. Is this not the case?

> Disclaimer: I have stake in AsicBoost, but I'm not sure about this.
>  
> 
> On Tue, May 10, 2016 at 5:27 PM, Tier Nolan via bitcoin-dev
> <[email-masked]
> <mailto:[email-masked]>> wrote:
> 
>     The various chunks in the double SHA256 are
> 
>     Chunk 1: 64 bytes
>     version
>     previous_block_digest
>     merkle_root[31:4]
> 
>     Chunk 2: 64 bytes
>     merkle_root[3:0]
>     nonce
>     timestamp
>     target
> 
>     Chunk 3: 64 bytes
>     digest from first sha pass
> 
>     Their improvement requires that all data in Chunk 2 is identical
>     except for the nonce.  With 4 bytes, the birthday paradox means
>     collisions can be found reasonable easily.
> 
>     If hard forks are allowed, then moving more of the merkle root into
>     the 2nd chunk would make things harder.  The timestamp and target
>     could be moved into chunk 1.  This increases the merkle root to 12
>     bytes in the 2nd chunk.  Finding collisions would be made much more
>     difficult.
> 
>     If ASIC limitations mean that the nonce must stay where it is, this
>     would mean that the merkle root would be split into two pieces.
> 
>     On Tue, May 10, 2016 at 7:57 PM, Peter Todd via bitcoin-dev
>     <[email-masked]
>     <mailto:[email-masked]>> wrote:
> 
>         As part of the hard-fork proposed in the HK agreement(1) we'd
>         like to make the
>         patented AsicBoost optimisation useless, and hopefully make
>         further similar
>         optimizations useless as well.
> 
>         What's the best way to do this? Ideally this would be SPV
>         compatible, but if it
>         requires changes from SPV clients that's ok too. Also the fix
>         this should be
>         compatible with existing mining hardware.
> 
> 
>         1)
>         https://medium.com/@bitcoinroundtable/bitcoin-roundtable-consensus-266d475a61ff
> 
>         2)
>         http://lists.linuxfoundation.org/pipermail/bitcoin-dev/2016-April/012596.html
> 
>         --
>         https://petertodd.org 'peter'[:-1]@petertodd.org
>         <http://petertodd.org>
> 
>         _______________________________________________
>         bitcoin-dev mailing list
>         [email-masked]
>         <mailto:[email-masked]>
>         https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
> 
> 
> 
>     _______________________________________________
>     bitcoin-dev mailing list
>     [email-masked]
>     <mailto:[email-masked]>
>     https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
> 
> 
> 
> 
> _______________________________________________
> bitcoin-dev mailing list
> [email-masked]
> https://lists.linuxfoundation.org/mailman/listinfo/bitcoin-dev
>